import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React, { useCallback } from 'react';
import classnames from 'classnames';
import './../external/imask/esm/index.js';
import './../external/react-imask/esm/mixin-4107a9f1.js';
import IMaskInput from './../external/react-imask/esm/input.js';
import './../external/prop-types/index.js';
import './../external/imask/esm/controls/input.js';
import './../external/imask/esm/masked/date.js';
import './../external/imask/esm/masked/pattern.js';
import './../external/imask/esm/masked/base.js';
import './../external/imask/esm/masked/factory.js';
import './../external/imask/esm/masked/regexp.js';
import './../external/imask/esm/masked/range.js';
import './../external/imask/esm/controls/mask-element.js';
import './../external/imask/esm/controls/html-mask-element.js';
import './../external/imask/esm/controls/html-contenteditable-mask-element.js';
import { parseMetadata } from '@highlight-ui/utils-commons';
import styles from './Input.module.scss.js';
import InputOutline from './InputOutline.js';

var InputWithRef = function (_a, ref) {
  var _b;

  var _c = _a.className,
      className = _c === void 0 ? '' : _c,
      _d = _a.disabled,
      disabled = _d === void 0 ? false : _d,
      inputClassName = _a.inputClassName,
      maskOptions = _a.maskOptions,
      _e = _a.metadata,
      metadata = _e === void 0 ? {} : _e,
      onMaskAccept = _a.onMaskAccept,
      onMaskComplete = _a.onMaskComplete,
      _f = _a.outline,
      outline = _f === void 0 ? 'default' : _f,
      _g = _a.prefix,
      prefix = _g === void 0 ? '' : _g,
      _h = _a.prefixVariant,
      prefixVariant = _h === void 0 ? 'transparent' : _h,
      _j = _a.suffix,
      suffix = _j === void 0 ? null : _j,
      _k = _a.focused,
      focused = _k === void 0 ? false : _k,
      _l = _a.fontStyle,
      fontStyle = _l === void 0 ? 'regular' : _l,
      restProps = __rest(_a, ["className", "disabled", "inputClassName", "maskOptions", "metadata", "onMaskAccept", "onMaskComplete", "outline", "prefix", "prefixVariant", "suffix", "focused", "fontStyle"]);

  var classNames = classnames(styles.inputElement, styles.input, (_b = {}, _b[styles.transparentPrefixed] = prefix && prefixVariant === 'transparent', _b[styles.suffixed] = suffix, _b[styles.fontMono] = fontStyle === 'mono', _b), inputClassName);
  var handleOnMaskAccept = useCallback(function (value, mask) {
    if (onMaskAccept) {
      onMaskAccept({
        value: value,
        unmaskedValue: mask.unmaskedValue
      });
    }
  }, [onMaskAccept]);
  var handleOnMaskComplete = useCallback(function (value, mask) {
    if (onMaskComplete) {
      onMaskComplete({
        value: value,
        unmaskedValue: mask.unmaskedValue
      });
    }
  }, [onMaskComplete]);
  return /*#__PURE__*/React.createElement(InputOutline, {
    className: className,
    disabled: disabled,
    focused: focused,
    outline: outline
  }, prefix && /*#__PURE__*/React.createElement("span", {
    className: classnames(styles.prefix, styles["variant-" + prefixVariant])
  }, prefix), maskOptions ? /*#__PURE__*/React.createElement(IMaskInput, __assign({
    disabled: disabled,
    inputRef: ref
  }, maskOptions, {
    onAccept: handleOnMaskAccept,
    onComplete: handleOnMaskComplete,
    className: classNames
  }, parseMetadata(metadata), restProps)) : /*#__PURE__*/React.createElement("input", __assign({
    ref: ref,
    className: classNames,
    disabled: disabled
  }, parseMetadata(metadata), restProps)), suffix && /*#__PURE__*/React.createElement("span", {
    className: styles.suffix
  }, suffix));
};

var Input = /*#__PURE__*/React.forwardRef(InputWithRef);
export { Input as default };
//# sourceMappingURL=Input.js.map
